<template lang="html">
  <v-card>
    <v-card-title>Actions</v-card-title>
    <v-card-text>
      <v-container v-for="(action, index) in actions" :key="index">
        <v-row>
          <v-col
            cols="12"
          >
            <v-text-field
              label="Target contract address"
              v-model="action.contract"
              @input="handleABI(index)"
            ></v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col
            cols="12"
          >
            <template>
              <v-file-input
                accept="application/json"
                label="ABI"
                v-model="action.artifact"
                @change="handleABI(index)"
              ></v-file-input>
            </template>
          </v-col>
        </v-row>
        <v-row align="center">
          <v-col
            class="d-flex"
            cols="12"
          >
            <v-select
              :items="action.methods"
              item-text="name"
              item-value="signature"
              v-model="action.methodName"
              label="Contract method"
            ></v-select>
          </v-col>
        </v-row>
        <v-row v-if="hasMethodParams(index)">
          <v-col>
            <method-params
              v-model="action.methodParams"
              :signature="action.methodSignatures[action.methodName]" />
          </v-col>
        </v-row>
        <v-row>
          <v-col
            cols="12"
          >
            <v-text-field
              label="Ether"
              v-model="action.value"
            ></v-text-field>
          </v-col>
        </v-row>
      </v-container>
    </v-card-text>
    <v-card-actions>
      <v-btn @click="add">Add</v-btn>
    </v-card-actions>
  </v-card>
</template>

<script>
import { ethers } from "ethers";
import MethodParams from "./method/Params";

export default {
  name: "List",
  components: {
    MethodParams
  },
  props: ["value"],
  computed: {
    actions: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit('input', value);
      }
    }
  },
  methods: {
    add() {
      this.actions.push({ method: { name: null, params: [] } });
    },
    async handleABI(index) {
      this.actions[index].methods = [];
      this.actions[index].methodSignatures = [];

      if (this.actions[index].contract && this.actions[index].artifact) {
        var reader = new FileReader();

        reader.readAsText(this.actions[index].artifact);

        await new Promise((resolve, ) => {
          reader.onload = () => {
            const provider = this.$store.state.provider;

            this.data = reader.result;
            this.actions[index].abi = JSON.parse(this.data).abi;

            resolve(reader);

            const contract = new ethers.Contract(
              this.actions[index].contract,
              this.actions[index].abi, provider);

            const txFunctions = [];
            const txFuncNames = [];

            Object.keys(contract.interface.functions).forEach(func => {
              const attributes = contract.interface.functions[func];

              if (attributes.stateMutability !== "view" && attributes.stateMutability !== "pure") {
                txFunctions[func] = attributes;
                txFuncNames.push({ name: attributes.name, signature: func });
              }
            });

            this.actions[index].methods = txFuncNames;
            this.actions[index].methodSignatures = txFunctions;
          }
        });
      }

      this.$set(this.actions, index, this.actions[index]);
    },
    hasMethodParams(index) {
      const action = this.actions[index];
      const methodName = action.methodName;

      if (methodName !== undefined) {
        const methodSignature = action.methodSignatures[methodName];
        if (methodSignature) {
          if (methodSignature.inputs.length !== 0) {
            return true;
          }
        }
      }

      return false;
    }
  }
}
</script>
